//+------------------------------------------------------------------+
//|                                                       bandsk.mq4 |
//|                       Copyright ?2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Black
#property indicator_color2 Green
#property indicator_color3 DarkGray
#property indicator_color4 Red
//---- input parameters
extern int       myperiod=20;
extern int       mydeviation=2;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ExtMapBuffer4);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i=0; i<limit; i++)
      ExtMapBuffer1[i]=iBands(NULL,0,myperiod, mydeviation,0,PRICE_CLOSE,MODE_UPPER,i)
                      -iBands(NULL,0,myperiod, mydeviation,0,PRICE_CLOSE,MODE_LOWER,i);
   for(i=0; i<limit; i++)
    {
      if(ExtMapBuffer1[i]<ExtMapBuffer1[i+1])   ExtMapBuffer2[i]=ExtMapBuffer1[i];
      if(ExtMapBuffer1[i]==ExtMapBuffer1[i+1])   ExtMapBuffer3[i]=ExtMapBuffer1[i];
      if(ExtMapBuffer1[i]>ExtMapBuffer1[i+1])   ExtMapBuffer4[i]=ExtMapBuffer1[i];
    }
    return(0);
  }
//+------------------------------------------------------------------+